﻿using Borepin.Model;
using Borepin.Service.BFFH;
using Borepin.Service.Connections;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Borepin.PageModel.AddServerProcess
{
    public class LoginPasswordPageModel : BindableBase
    {
        private readonly INavigationService _NavigationService;
        private readonly IBFFHService _BFFHService;
        private readonly IConnectionService _ConnectionService;

        public LoginPasswordPageModel(INavigationService navigationService, IBFFHService bffhService, IConnectionService connectionService)
        {
            _NavigationService = navigationService;
            _BFFHService = bffhService;
            _ConnectionService = connectionService;

            AuthenticateCommand = new DelegateCommand(async () => await AuthenticateCommandExecuted());

            Task.Run(LoadData);
        }

        private void LoadData()
        {

        }

        private string _Username;
        public string Username
        {
            get => _Username;
            set => SetProperty(ref _Username, value);
        }

        private string _Password;
        public string Password
        {
            get => _Password;
            set => SetProperty(ref _Password, value);
        }

        private ICommand _AuthenticateCommand;
        public ICommand AuthenticateCommand
        {
            get => _AuthenticateCommand;
            set => SetProperty(ref _AuthenticateCommand, value);
        }

        private async Task AuthenticateCommandExecuted()
        {
            Connection connection_update = _BFFHService.ActiveConnection;

            connection_update.Username = Username;

            await _BFFHService.Authenticate(connection_update, Password).ConfigureAwait(false);

            try
            {
                await _ConnectionService.AddConnection(_BFFHService.ActiveConnection);
            }
            catch (ArgumentException)
            {

            }

            await _ConnectionService.LogConnect(_BFFHService.ActiveConnection);

            var result = await _NavigationService.NavigateAsync("/MainPage/NavigationPage/MachineListPage");

            if (!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }
    }
}